/*
 *                  - Mellanox Confidential and Proprietary -
 *
 *  Copyright (C) January 2010, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "LICENSE.txt".
 *
 */

#ifndef __SXD_EMAD_REDECN_DATA_H__
#define __SXD_EMAD_REDECN_DATA_H__

#include <sx/sxd/sxd_types.h>
#include <sx/sxd/sxd_emad_common_data.h>

/************************************************
 *  Local Defines
 ***********************************************/

/************************************************
 *  Local Macros
 ***********************************************/

/************************************************
 *  Local Type definitions
 ***********************************************/

/************************************************
 *  Defines
 ***********************************************/

/************************************************
 *  Macros
 ***********************************************/

/************************************************
 *  Type definitions
 ***********************************************/

/**
 * sxd_emad_qpdp_data_t structure is used to store QPDP register
 * data.
 */
typedef struct sxd_emad_cwgcr_data {
    sxd_emad_common_data_t common;
    struct ku_cwgcr_reg   *reg_data;
} sxd_emad_cwgcr_data_t;

typedef struct sxd_emad_cwtp_data {
    sxd_emad_common_data_t common;
    struct ku_cwtp_reg    *reg_data;
} sxd_emad_cwtp_data_t;

typedef struct sxd_emad_cwtpm_data {
    sxd_emad_common_data_t common;
    struct ku_cwtpm_reg   *reg_data;
} sxd_emad_cwtpm_data_t;

typedef struct sxd_emad_cwpp_data {
    sxd_emad_common_data_t common;
    struct ku_cwpp_reg    *reg_data;
} sxd_emad_cwpp_data_t;

typedef struct sxd_emad_cwppm_data {
    sxd_emad_common_data_t common;
    struct ku_cwppm_reg   *reg_data;
} sxd_emad_cwppm_data_t;

typedef struct sxd_emad_cpqe_data {
    sxd_emad_common_data_t common;
    struct ku_cpqe_reg    *reg_data;
} sxd_emad_cpqe_data_t;


#endif /* __SXD_EMAD_REDECN_DATA_H__ */
